//
//  FBManager.m
//  FirebaseCppTestApp
//

#import "FBManager.h"

#import "firebase/firestore.h"
#import "firebase/auth.h"


// Add your Firebase project here
#define FIREBASE_PROJECT_ID "your-project-id"
#define FIREBASE_APP_ID "your-app-id"
#define FIREBASE_API_KEY "your-api-key"


static firebase::App* fbApp = nullptr;

@implementation FBManager

- (IBAction)pushLogin:(id)sender {
    // Create Firebase app instance 
    auto options = firebase::AppOptions();
    options.set_project_id(FIREBASE_PROJECT_ID);
    options.set_app_id(FIREBASE_APP_ID);
    options.set_api_key(FIREBASE_API_KEY);
    
    fbApp = firebase::App::Create(options);
    
    // Authenticate user with email and password
    NSString* userName = _usernameField.stringValue;
    NSString* password = _passwordField.stringValue;
    
    firebase::auth::Auth* auth = firebase::auth::Auth::GetAuth(fbApp);
    firebase::Future<firebase::auth::User*> sign_in_future = auth->SignInWithEmailAndPassword(userName.UTF8String, password.UTF8String);
    
    sign_in_future.OnCompletion(^(const firebase::Future<firebase::auth::User *>& future){
        BOOL success = future.error() == firebase::auth::kAuthErrorNone;
        dispatch_async(dispatch_get_main_queue(), ^{
            if (!success) {
                NSLog(@"Auth error: %@.", [NSString stringWithUTF8String:sign_in_future.error_message()]);
            } else {
                NSLog(@"Auth success.");
                self->userId = [NSString stringWithUTF8String:auth->current_user()->uid().c_str()];
            }
            
            // After logging Auth success, CPU utilisation is high, when running in sandbox on macOS desktop.
            // This issue does not occur when running with sandboxing disabled in the FirebaseCppTestApp.entitlements.
        });
    });
}

@end
